import java.awt.*;

public class ring extends Panel
{
	private boolean first = true;
	
	public int groesse = 200;
	private Dimension mom_gr; 
	private Point mitte;
	private String m_FontName   = "TimesRoman";
  private int    m_NumSize    = 16;
	private Image dbImage = null;
	private Graphics dbGraphics;
  private Font font;
	public String zahlen[] = {"0","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16"};
	private int PfeilPos = 0;
	
	
	ring()
	{
		super();
		mom_gr = size();
		font = new Font(m_FontName, Font.BOLD, m_NumSize);
		setFont(font);
	}
	
	private void vorZeichnen(Graphics g)
	{
		//if (dbImage == null)
		{
	  	dbImage=createImage(this.size().width,this.size().height);
	  dbGraphics = dbImage.getGraphics();
		}
//      dbGraphics.setClip(0,0,getSize().width, getSize().height);
//		super.paint(dbGraphics);

		moduloArithmetik ma = new moduloArithmetik(zahlen.length);
		
		int textwidth, textheight;
		int rad;
		mom_gr = getSize();
		mitte = new Point(mom_gr.width /2 ,mom_gr.height / 2);
		if (mom_gr.width > mom_gr.height)
		{
			rad = (int)(mom_gr.height / 2.5);
		}else{
			rad = (int)(mom_gr.width  / 2.5);
		}
		
		for (int i = 0;i < zahlen.length;i++)
		{
			Point TextPos;
			double winkel  = ((Math.PI * 2) / zahlen.length)* i;
			textwidth = getFontMetrics(font).stringWidth(zahlen[i])/2;
			textheight = getFontMetrics(font).getHeight()/2;
			TextPos = new Point((int)(Math.sin(winkel) * rad),(int)(Math.cos(winkel) * rad));
			if (i == ma.betrag(PfeilPos))
			{ 
				Color backup = dbGraphics.getColor();
				dbGraphics.setColor(Color.red);
				dbGraphics.drawLine(mitte.x, mitte.y, mitte.x + (int)(Math.sin(winkel) * (rad*0.75)), mitte.y - (int)(Math.cos(winkel) * (rad*0.75)));
				dbGraphics.drawString(zahlen[i],mitte.x + TextPos.x - textwidth, mitte.y - (TextPos.y - textheight));
				dbGraphics.setColor(backup);
			}else{			
				dbGraphics.drawString(zahlen[i],mitte.x + TextPos.x - textwidth, mitte.y - (TextPos.y - textheight));
			}

		}
				
//		paint(dbGraphics);
//		//Offscreen anzeigen
		g.drawImage(dbImage,0,0,this);
		
	}
	
  public void update(Graphics g)
	{
		vorZeichnen(g);
	}
	
	public void paint(Graphics g)
	{
			vorZeichnen(g);
	}
	
	public void repaint()
	{
		vorZeichnen(getGraphics());
	}

	public void validate()
	{
		vorZeichnen(getGraphics());
	}
	
	public void next()
	{
		PfeilPos++;
		repaint();
	}
	
	public void prev()
	{
		PfeilPos--;
		repaint();
	}
	
	public Dimension getPreferredSize()
	{
		return new Dimension(groesse,groesse);
	}

	public Dimension getMinimumSize()
	{
		return new Dimension(groesse / 2,groesse / 2);
	}

	public int getPfeilPos()
	{
		return this.PfeilPos;
	}

	public void setPfeilPos(int PfeilPos)
	{
		this.PfeilPos = PfeilPos;
		repaint();
	}
}