
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

public class kontext extends Applet
{
	
	// Parameter
    private String m_Datei      = "/dir.txt";
    private String m_Target			= "kontext";
    private Color m_vorderGrund = new Color(0, 0, 0); 
    private Color m_hinterGrund = new Color(255, 204, 102); //#FFCC66

  // Parameter Nemen.  Um den Namen eines Parameters zu ndern, ist nur eine nderung zu machen
	//                   Einfach den Wert des Parameters in folgender Liste ndern.
  //--------------------------------------------------------------------------
	private final String PARAM_Datei  = "Datei";
	private final String PARAM_vorderG= "vorderGrundFarbe";
	private final String PARAM_hinterG= "hinterGrundFarbe";
	private final String PARAM_targetFrame= "targetFrame";
	
	
	
	
	// Sonstige Variablem
	//--------------------------------------------------------------------------
	Button L_zurueck = new Button("<<");
	Button L_vor			= new Button(">>");//,Label.RIGHT);
	TextField	tf_such = new TextField("Suchtext");
	String[] seiten = null;
	Applet thisApplet;
	
	int aktuelleSeite = 0;
	int anzSeiten = 0;
	
	
	
	public void init()
	{
		this.setLayout(new GridLayout(1,3));
		this.add(L_zurueck);
		this.add(tf_such);		
		this.add(L_vor);		
		
		
		thisApplet = this;
		
		
		seiten = getDateiList(m_Datei);
		System.out.println(seiten.length);
		for (int i = 0; i < seiten.length;i++)
		{
				System.out.println(seiten[i]);
		}
//		L_zurueck.addMouseListener(new EinSchrittListener());
//		L_vor.addMouseListener(new EinSchrittListener());

		L_zurueck.addActionListener(new EinSchrittListener());
		L_vor.addActionListener(new EinSchrittListener());
		tf_such.addTextListener(new suchListener());
		
    L_zurueck.setBackground(m_hinterGrund);
    L_zurueck.setForeground(m_vorderGrund);
    L_vor.setBackground(m_hinterGrund);
    L_vor.setForeground(m_vorderGrund);
    setBackground(m_hinterGrund);
    setForeground(m_vorderGrund);

	}
	
	/*public void update(Graphics g)
	{
	   //Hintergrund lschen
	   g.fillRect(0,0,this.size().width,this.size().height);
	}*/

	
	
  public void start()
	{
		
	}
	
	
    public void stop()
	{
	}

	public String getAppletInfo()
	{
		return "Name: kontext\r\n" +
		       "Author: Thomas Laubrock\r\n" +
		       "Firma: secunet AG\r\n"+
		       "copyright 1999 by Thomas Laubrock";
	}

	public String[][] getParameterInfo()
	{
		String[][] info =
		{
			{ PARAM_Datei, "String", "Pfad+Datei mit Liste der Dateinamen" },
			{ PARAM_vorderG, "String", "Vordergrund- und Schriftfarbe" },
			{ PARAM_hinterG, "String", "Hinetrgrungfarbe" },
			{ PARAM_targetFrame,"String", "target, bwz. Ziel-Frame, indas Dateien geladen werden"}
		};
		return info;		
	}
	
	private String[] getDateiList(String DateiPfad)
	{
	 	String out[] = new String[100];
		String out2[] = new String[1];
		int i = 0;
		InputStream is = null;
 		try{
 			
System.out.println("Anfang: " + DateiPfad);		
System.out.println(this.getCodeBase());
			is = this.getClass().getResourceAsStream(DateiPfad);
			if (is == null)
 			{
System.out.println("Mit getResourceAsStream() nix zu holen: " + DateiPfad);		
// 				URL	inUrl = this.getClass().getResource("/"+DateiPfad);
				URL inUrl = new URL(getCodeBase() + DateiPfad);
				if (inUrl == null)
 				{
System.out.println("Mit getResource() nix zu holen: " + DateiPfad);		
 					inUrl = this.getClass().getResource(DateiPfad);
 				}
				is = inUrl.openStream();
			 				
 			}
System.out.println("INputStream: "+ is); 			
		}catch(Exception ex1){
		try{
			//URL inUrl = new URL(getCodeBase() +"/"+DateiPfad);
			//is = inUrl.openStream();
 				ex1.printStackTrace();  			
			
			
 		}catch(Exception ex2){
 				ex2.printStackTrace();  			
 		}}

		try{
			Reader r = new BufferedReader(new InputStreamReader(is));
			LineNumberReader lnr = new LineNumberReader(r);
			
			out[i] = lnr.readLine();
			
			while(out[i] != null)
 			{
 				i++;
				out[i] = lnr.readLine();
 			}
 			out2 = new String[i];
 			for (int j = 0;j < i;j++)
 			{
 				out2[j]= out[j];
 	System.out.println("Gelesene Zeile: "+ out2[j]);
 			}
 		}catch(IOException ioe){
 				ioe.printStackTrace();  			
 		}
			

 		return out2;
	}
	
	private void leseParameter()
	{
		String param;
		param = getParameter(PARAM_Datei);
		if (param != null) m_Datei = param;

		param = getParameter(PARAM_targetFrame);
		if (param != null) m_Target = param;

		param = getParameter(PARAM_vorderG);
		try{
			if (param != null) m_vorderGrund = new Color(Integer.decode(param).intValue());
    }
    catch(NumberFormatException e)
    {
    }

		param = getParameter(PARAM_hinterG);
		try{	
			if (param != null) m_hinterGrund = new Color(Integer.decode(param).intValue());
    }
    catch(NumberFormatException e)
    {
    }

	}
	
	
	//=========== Lauftzeit Funktionen ==========================
	public void sucheSeiteJS(String s)
	{
		sucheSeite(s, false);		
	}
	
	public boolean sucheSeite(String s, boolean set)
	{
System.out.println("Seite "+s+" wird gesucht!");
		
		for (int i = 0; i < seiten.length;  i++)
		{
			if(seiten[i].startsWith(s)) 
			{
System.out.println("Seite gefunden: " + seiten[i]+"] beginnt mit "+s);
		
				if (set) {
					setzeSeite(i);		
				}else{
					aktuelleSeite = i;
				}
				return true;
			}
		}
		return false;
	}
	
	public void setzeSeite(int index)
	{
		try{try{
System.out.println("Setze Datei: "+new URL(getCodeBase() +"/"+ seiten[aktuelleSeite]));				
			aktuelleSeite = index;
			String  url_s = getCodeBase().toString();
			if (!(url_s.endsWith("/")))
			{ url_s = url_s + "/";	}
			if (seiten[aktuelleSeite].startsWith("/"))
			{	seiten[aktuelleSeite] = seiten[aktuelleSeite].substring(1,seiten[aktuelleSeite].length()-1);}
			thisApplet.getAppletContext().showDocument(new URL(url_s+ seiten[aktuelleSeite]),m_Target);
		}catch(Exception e){System.out.println("Index falsch!");}	
		}catch( MalformedURLException mue){
System.out.println("Es ist ein Fehler in der Dateiliste!");				
		}
	}
	
	public void setzeSeiteRelativ(int i)
	{
		System.out.println(seiten[1]);
		if ((aktuelleSeite + i >= 0) & (aktuelleSeite + i < seiten.length))
		{
				aktuelleSeite += i;
				setzeSeite(aktuelleSeite);
		}else{
			Toolkit.getDefaultToolkit().beep();
		}
		
	}
	
//============== Event Listener =====================	
	class EinSchrittListener implements ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent e) 
		{	

			if (e.getSource() == L_zurueck)
			{
				setzeSeiteRelativ(-1);
			}else{if (e.getSource() == L_vor)
			{
				setzeSeiteRelativ(+1);
			}
			}
		}
	}
	/*class EinSchrittListener extends MouseAdapter
	{
		public void mouseClicked(java.awt.event.MouseEvent e) 
		{	
			if (e.getComponent() == L_zurueck)
			{
				setzeSeite(-1);
			}else{if (e.getComponent() == L_vor)
			{
				setzeSeite(-1);
			}
			}
		}
	}*/
	
	class suchListener implements TextListener
	{
		public void textValueChanged(TextEvent e)
		{
			if(!(sucheSeite(tf_such.getText(),true)))
			{
				
				tf_such.setText(tf_such.getText().substring(0, tf_such.getText().length()-1));
			}
		}
		
	}


	
}